package PMG::RS::Acme;

use strict;
use warnings;
use DynaLoader ();

my $LIB;

BEGIN {
    my sub newXS {
        my ($perl_func_name, $full_symbol_name, $filename) = @_;

        my $sym  = DynaLoader::dl_find_symbol($LIB, $full_symbol_name);
        die "failed to locate '$full_symbol_name'\n" if !defined $sym;
        DynaLoader::dl_install_xsub($perl_func_name, $sym, $filename);
    }

    my sub __load_shared_lib {
        return if $LIB;

        my ($pkg) = @_;

        my ($mod_name) = ('pmg_rs');

        my @dirs = (map "-L$_/auto", @INC);
        my (@mod_files) = DynaLoader::dl_findfile(@dirs, $mod_name);
        die "failed to locate shared library for '$pkg' (lib${mod_name}.so)\n" if !@mod_files;

        $LIB = DynaLoader::dl_load_file($mod_files[0])
            or die "failed to load library '$mod_files[0]'\n";
    }

    __load_shared_lib(__PACKAGE__);
    newXS('new', 'xs_PMG__RS__Acme_new', "src/FIXME.rs");
    newXS('load', 'xs_PMG__RS__Acme_load', "src/FIXME.rs");
    newXS('DESTROY', 'xs_PMG__RS__Acme_destroy', "src/FIXME.rs");
    newXS('new_account', 'xs_PMG__RS__Acme_new_account', "src/FIXME.rs");
    newXS('get_meta', 'xs_PMG__RS__Acme_get_meta', "src/FIXME.rs");
    newXS('directory', 'xs_PMG__RS__Acme_directory', "src/FIXME.rs");
    newXS('account', 'xs_PMG__RS__Acme_account', "src/FIXME.rs");
    newXS('location', 'xs_PMG__RS__Acme_location', "src/FIXME.rs");
    newXS('tos_url', 'xs_PMG__RS__Acme_tos_url', "src/FIXME.rs");
    newXS('debug', 'xs_PMG__RS__Acme_debug', "src/FIXME.rs");
    newXS('set_debug', 'xs_PMG__RS__Acme_set_debug', "src/FIXME.rs");
    newXS('new_order', 'xs_PMG__RS__Acme_new_order', "src/FIXME.rs");
    newXS('get_authorization', 'xs_PMG__RS__Acme_get_authorization', "src/FIXME.rs");
    newXS('get_order', 'xs_PMG__RS__Acme_get_order', "src/FIXME.rs");
    newXS('key_authorization', 'xs_PMG__RS__Acme_key_authorization', "src/FIXME.rs");
    newXS('dns_01_txt_value', 'xs_PMG__RS__Acme_dns_01_txt_value', "src/FIXME.rs");
    newXS('request_challenge_validation', 'xs_PMG__RS__Acme_request_challenge_validation', "src/FIXME.rs");
    newXS('finalize_order', 'xs_PMG__RS__Acme_finalize_order', "src/FIXME.rs");
    newXS('get_certificate', 'xs_PMG__RS__Acme_get_certificate', "src/FIXME.rs");
    newXS('update_account', 'xs_PMG__RS__Acme_update_account', "src/FIXME.rs");
    newXS('revoke_certificate', 'xs_PMG__RS__Acme_revoke_certificate', "src/FIXME.rs");
}
